from collections import defaultdict
import subprocess

def command(*base_args):
    def callable_command(*args):
        return subprocess.check_output(base_args+args, shell=False)

    return callable_command


def run(*args):
    return subprocess.check_output(args, shell=False)


class Config(defaultdict):

    def __init__(self):
        super(defaultdict, self).__init__()
        self.config_get = command('config-get')

    def __missing__(self, key):
        return self.config_get(key).strip()

    def __setitem__(self, key, value):
        raise RuntimeError('configuration is read-only')
